#pragma once

#include <windows.h>
#include <cstdlib>
#include "d3dclass.h"
#include "cameraclass.h"
#include "modelclass.h"
#include "AxisModelClass.h"
#include "colorshaderclass.h"
#include "WaterModelClass.h"

/////////////
// GLOBALS //
/////////////
const bool FULL_SCREEN = false;//Ƿȫ
const bool VSYNC_ENABLED = true;//Ƿֱͬ
const float SCREEN_DEPTH = 1000.0f;//ȣԶ
const float SCREEN_NEAR = 0.1f;//ȣ

class GraphicsClass
	{
	public:
		GraphicsClass(void);
		GraphicsClass(const GraphicsClass&);
		~GraphicsClass(void);
		bool Initialize(int, int, HWND);
		void Shutdown();
		bool Frame(float);
		CameraClass* m_Camera;//ΪpublicSystemClassп
		WaterModelClass* m_WaterModel;
	private:
		bool Render(float);

		//һD3DClassԱ
		D3DClass* m_D3D;
		
		ModelClass* m_Model;
		AxisModelClass* m_AxisModel;
		ColorShaderClass* m_ColorShader;

	};

