#include "ColorShaderClass.h"


ColorShaderClass::ColorShaderClass(void)
	{
	m_vertexShader = 0;
	m_pixelShader = 0;
	m_layout = 0;
	m_matrixBuffer = 0;

	}

ColorShaderClass::ColorShaderClass(const ColorShaderClass& other)
	{
	}


ColorShaderClass::~ColorShaderClass(void)
	{
	}

bool ColorShaderClass::Initialize(ID3D11Device* device, HWND hwnd)
	{
	bool result;


	// ʼvs ps.
	result = InitializeShader(device, hwnd, L"color.vs", L"color.ps");
	if(!result)
		{
		return false;
		}

	return true;
	}
void ColorShaderClass::Shutdown()
	{
	// ͷshaderԴ.
	ShutdownShader();

	return;
	}
bool ColorShaderClass::Render(ID3D11DeviceContext* deviceContext, int indexCount, D3DXMATRIX worldMatrix, 
	D3DXMATRIX viewMatrix, D3DXMATRIX projectionMatrix)
	{
	bool result;


	// shader.
	result = SetShaderParameters(deviceContext, worldMatrix, viewMatrix, projectionMatrix);
	if(!result)
		{
		HR(result);
		return false;
		}

	// shaderȾָ嶥
	RenderShader(deviceContext, indexCount);

	return true;
	}

bool ColorShaderClass::InitializeShader(ID3D11Device* device, HWND hwnd, WCHAR* vsFilename, WCHAR* psFilename)
	{
	HRESULT result;
	ID3D10Blob* errorMessage;
	ID3D10Blob* vertexShaderBuffer;
	ID3D10Blob* pixelShaderBuffer;
	D3D11_INPUT_ELEMENT_DESC polygonLayout[2];
	unsigned int numElements;
	D3D11_BUFFER_DESC matrixBufferDesc;


	// ʼָΪ.
	errorMessage = 0;
	vertexShaderBuffer = 0;
	pixelShaderBuffer = 0;

	// vs.
	result = D3DX11CompileFromFile(vsFilename, NULL, NULL, "ColorVertexShader", "vs_5_0", D3D10_SHADER_ENABLE_STRICTNESS, 0, NULL, 
		&vertexShaderBuffer, &errorMessage, NULL);
	if(FAILED(result))
		{
		// vsʧܣϢ.
		if(errorMessage)
			{
			OutputShaderErrorMessage(errorMessage, hwnd, vsFilename);
			}
		// ûκδϢshaderļʧ.
		else
			{
			MessageBox(hwnd, vsFilename, L"Missing Shader File", MB_OK);
			}
		HR(result);
		return false;
		}

	// ps.
	result = D3DX11CompileFromFile(psFilename, NULL, NULL, "ColorPixelShader", "ps_5_0", D3D10_SHADER_ENABLE_STRICTNESS, 0, NULL, 
		&pixelShaderBuffer, &errorMessage, NULL);
	if(FAILED(result))
		{
		// psʧܣϢ.
		if(errorMessage)
			{
			OutputShaderErrorMessage(errorMessage, hwnd, psFilename);
			}
		// ûκδϢshaderļʧ.
		else
			{
			MessageBox(hwnd, psFilename, L"Missing Shader File", MB_OK);
			}
		HR(result);
		return false;
		}


	// ӻ崴vs shader.
	result = device->CreateVertexShader(vertexShaderBuffer->GetBufferPointer(), vertexShaderBuffer->GetBufferSize(), NULL, &m_vertexShader);
	if(FAILED(result))
		{
		HR(result);
		return false;
		}

	// ӻ崴ps shader.
	result = device->CreatePixelShader(pixelShaderBuffer->GetBufferPointer(), pixelShaderBuffer->GetBufferSize(), NULL, &m_pixelShader);
	if(FAILED(result))
		{
		HR(result);
		return false;
		}

	// ݲ֣Աshaderʹ.
	// ҪModelClassеĶṹһ.
	polygonLayout[0].SemanticName = "POSITION";//vsе 
	polygonLayout[0].SemanticIndex = 0;
	polygonLayout[0].Format = DXGI_FORMAT_R32G32B32_FLOAT;
	polygonLayout[0].InputSlot = 0;
	polygonLayout[0].AlignedByteOffset = 0;
	polygonLayout[0].InputSlotClass = D3D11_INPUT_PER_VERTEX_DATA;
	polygonLayout[0].InstanceDataStepRate = 0;

	polygonLayout[1].SemanticName = "COLOR";
	polygonLayout[1].SemanticIndex = 0;
	polygonLayout[1].Format = DXGI_FORMAT_R32G32B32A32_FLOAT;
	polygonLayout[1].InputSlot = 0;
	polygonLayout[1].AlignedByteOffset = D3D11_APPEND_ALIGNED_ELEMENT;
	polygonLayout[1].InputSlotClass = D3D11_INPUT_PER_VERTEX_DATA;
	polygonLayout[1].InstanceDataStepRate = 0;

	// õlayoutеԪ
	numElements = sizeof(polygonLayout) / sizeof(polygonLayout[0]);

	// 벼.
	result = device->CreateInputLayout(polygonLayout, numElements, vertexShaderBuffer->GetBufferPointer(), 
		vertexShaderBuffer->GetBufferSize(), &m_layout);
	if(FAILED(result))
		{
		HR(result);
		return false;
		}

	//ͷŶػ.
	vertexShaderBuffer->Release();
	vertexShaderBuffer = 0;

	pixelShaderBuffer->Release();
	pixelShaderBuffer = 0;

	// ö̬.
	matrixBufferDesc.Usage = D3D11_USAGE_DYNAMIC;
	matrixBufferDesc.ByteWidth = sizeof(MatrixBufferType);
	matrixBufferDesc.BindFlags = D3D11_BIND_CONSTANT_BUFFER;
	matrixBufferDesc.CPUAccessFlags = D3D11_CPU_ACCESS_WRITE;
	matrixBufferDesc.MiscFlags = 0;
	matrixBufferDesc.StructureByteStride = 0;

	// const bufferָ룬Աshader.
	result = device->CreateBuffer(&matrixBufferDesc, NULL, &m_matrixBuffer);
	if(FAILED(result))
		{
		HR(result);
		return false;
		}

	return true;
	}

void ColorShaderClass::ShutdownShader()
	{
	// ͷų
	if(m_matrixBuffer)
		{
		m_matrixBuffer->Release();
		m_matrixBuffer = 0;
		}

	//ͷŶ㲼t.
	if(m_layout)
		{
		m_layout->Release();
		m_layout = 0;
		}

	// ͷps .
	if(m_pixelShader)
		{
		m_pixelShader->Release();
		m_pixelShader = 0;
		}

	// ͷvs
	if(m_vertexShader)
		{
		m_vertexShader->Release();
		m_vertexShader = 0;
		}

	return;
	}

void ColorShaderClass::OutputShaderErrorMessage(ID3D10Blob* errorMessage, HWND hwnd, WCHAR* shaderFilename)
	{
	char* compileErrors;
	unsigned long bufferSize, i;
	ofstream fout;


	// õϢbufferָ.
	compileErrors = (char*)(errorMessage->GetBufferPointer());

	// õbufferĳ.
	bufferSize = errorMessage->GetBufferSize();

	// һļдϢ.
	fout.open("shader-error.txt");

	// .
	for(i=0; i<bufferSize; i++)
		{
		fout << compileErrors[i];
		}

	// رļ
	fout.close();

	// ͷŴϢ.
	errorMessage->Release();
	errorMessage = 0;

	//ʾ.
	MessageBox(hwnd, L"Error compiling shader.  Check shader-error.txt for message.", shaderFilename, MB_OK);

	return;
	}

bool ColorShaderClass::SetShaderParameters(ID3D11DeviceContext* deviceContext, D3DXMATRIX worldMatrix, 
	D3DXMATRIX viewMatrix, D3DXMATRIX projectionMatrix)
	{
	HRESULT result;
	D3D11_MAPPED_SUBRESOURCE mappedResource;
	MatrixBufferType* dataPtr;
	unsigned int bufferNumber;

	// shaderǰȷתãD3D11Ҫ.
	D3DXMatrixTranspose(&worldMatrix, &worldMatrix);
	D3DXMatrixTranspose(&viewMatrix, &viewMatrix);
	D3DXMatrixTranspose(&projectionMatrix, &projectionMatrix);

	//  壬Աܹд.
	result = deviceContext->Map(m_matrixBuffer, 0, D3D11_MAP_WRITE_DISCARD, 0, &mappedResource);
	if(FAILED(result))
		{
		HR(result);
		return false;
		}

	// õconst bufferָ.
	dataPtr = (MatrixBufferType*)mappedResource.pData;

	// world,viewԼprojection.
	dataPtr->world = worldMatrix;
	dataPtr->view = viewMatrix;
	dataPtr->projection = projectionMatrix;

	// .
	deviceContext->Unmap(m_matrixBuffer, 0);

	// óλ.
	bufferNumber = 0;

	// øºֵó.
	deviceContext->VSSetConstantBuffers(bufferNumber, 1, &m_matrixBuffer);

	return true;
	}

void ColorShaderClass::RenderShader(ID3D11DeviceContext* deviceContext, int indexCount)
	{
	// 󶨶㲼.
	deviceContext->IASetInputLayout(m_layout);

	// Ⱦʹvsps.
	deviceContext->VSSetShader(m_vertexShader, NULL, 0);
	deviceContext->PSSetShader(m_pixelShader, NULL, 0);

	// Ⱦ
	deviceContext->DrawIndexed(indexCount, 0, 0);

	return;
	}
