#include "CameraClass.h"


CameraClass::CameraClass(void)
	{
	_cameraType = AIRCRAFT;

	_pos   = D3DXVECTOR3(0.0f, 0.0f, 0.0f);
	_right = D3DXVECTOR3(1.0f, 0.0f, 0.0f);
	_up    = D3DXVECTOR3(0.0f, 1.0f, 0.0f);
	_look  = D3DXVECTOR3(0.0f, 0.0f, 1.0f);

	}

CameraClass::CameraClass(const CameraClass& other)
	{
	}

CameraClass::~CameraClass(void)
	{
	}

void CameraClass::Reset()
	{
	_pos   = D3DXVECTOR3(0.0f, 0.0f, 0.0f);
	_right = D3DXVECTOR3(1.0f, 0.0f, 0.0f);
	_up    = D3DXVECTOR3(0.0f, 1.0f, 0.0f);
	_look  = D3DXVECTOR3(0.0f, 0.0f, 1.0f);
	}

void CameraClass::getPosition(D3DXVECTOR3* pos)
	{
	*pos = _pos;
	}

void CameraClass::setPosition(D3DXVECTOR3* pos)
	{
	_pos = *pos;
	}

void CameraClass::getRight(D3DXVECTOR3* right)
	{
	*right = _right;
	}

void CameraClass::getUp(D3DXVECTOR3* up)
	{
	*up = _up;
	}

void CameraClass::getLook(D3DXVECTOR3* look)
	{
	*look = _look;
	}

//ߣ۲췽ƶ
void CameraClass::walk(float units)
	{
	// x,zƽƶ
	if( _cameraType == LANDOBJECT )
		_pos += D3DXVECTOR3(_look.x, 0.0f, _look.z) * units;

	if( _cameraType == AIRCRAFT )
		_pos += _look * units;
	}

//ɨӣָֹ۲췽򲻱䣬rightһƽƵһ
void CameraClass::strafe(float units)
	{
	// x,zƽƶ
	if( _cameraType == LANDOBJECT )
		_pos += D3DXVECTOR3(_right.x, 0.0f, _right.z) * units;

	if( _cameraType == AIRCRAFT )
		_pos += _right * units;
	}
//ģʽָupƶ
void CameraClass::fly(float units)
	{
	// yƶ
	if( _cameraType == LANDOBJECT )
		_pos.y += units;

	if( _cameraType == AIRCRAFT )
		_pos += _up * units;
	}

void CameraClass::pitch(float angle)
	{
	D3DXMATRIX T;
	D3DXMatrixRotationAxis(&T, &_right, angle);

	// rightתuplook
	D3DXVec3TransformCoord(&_up,&_up, &T);
	D3DXVec3TransformCoord(&_look,&_look, &T);
	}

void CameraClass::yaw(float angle)
	{
	D3DXMATRIX T;

	//LANDOBJECT,(0,1,0)ת
	if( _cameraType == LANDOBJECT )
		D3DXMatrixRotationY(&T, angle);

	//aircraft,upת
	if( _cameraType == AIRCRAFT )
		D3DXMatrixRotationAxis(&T, &_up, angle);

	// upyᣬתrightlook
	D3DXVec3TransformCoord(&_right,&_right, &T);
	D3DXVec3TransformCoord(&_look,&_look, &T);
	}

void CameraClass::roll(float angle)
	{
	//ֻaircraftģʽrollת
	if( _cameraType == AIRCRAFT )
		{
		D3DXMATRIX T;
		D3DXMatrixRotationAxis(&T, &_look, angle);

		// lookתupright
		D3DXVec3TransformCoord(&_right,&_right, &T);
		D3DXVec3TransformCoord(&_up,&_up, &T);
		}
	}

void CameraClass::getViewMatrix(D3DXMATRIX* V)
	{
	// viewֲϵı˴
	D3DXVec3Normalize(&_look, &_look);

	D3DXVec3Cross(&_up, &_look, &_right);
	D3DXVec3Normalize(&_up, &_up);

	D3DXVec3Cross(&_right, &_up, &_look);
	D3DXVec3Normalize(&_right, &_right);

	// view:
	float x = -D3DXVec3Dot(&_right, &_pos);
	float y = -D3DXVec3Dot(&_up, &_pos);
	float z = -D3DXVec3Dot(&_look, &_pos);

	(*V)(0,0) = _right.x; (*V)(0, 1) = _up.x; (*V)(0, 2) = _look.x; (*V)(0, 3) = 0.0f;
	(*V)(1,0) = _right.y; (*V)(1, 1) = _up.y; (*V)(1, 2) = _look.y; (*V)(1, 3) = 0.0f;
	(*V)(2,0) = _right.z; (*V)(2, 1) = _up.z; (*V)(2, 2) = _look.z; (*V)(2, 3) = 0.0f;
	(*V)(3,0) = x;        (*V)(3, 1) = y;     (*V)(3, 2) = z;       (*V)(3, 3) = 1.0f;
	}

void CameraClass::setCameraType(CameraType cameraType)
	{
	_cameraType = cameraType;
	}

