#include "LightShaderClass.h"


LightShaderClass::LightShaderClass(void)
	{
	m_vertexShader = 0;
	m_pixelShader = 0;
	m_layout = 0;
	m_matrixBuffer = 0;
	m_lightmaterialBuffer = 0;

	}

LightShaderClass::LightShaderClass(const LightShaderClass & others)
	{

	}

LightShaderClass::~LightShaderClass(void)
	{
	}

bool LightShaderClass::Initialize(ID3D11Device* device, HWND hwnd)
	{
	bool result;

	// ʼvsps.
	result = InitializeShader(device, hwnd, L"light.vs", L"light.ps");
	if(!result)
		{
		return false;
		}

	return true;
	}

void LightShaderClass::Shutdown()
	{
	// ͷshaderԴ.
	ShutdownShader();

	return;
	}

bool LightShaderClass::Render(ID3D11DeviceContext* deviceContext, int indexCount, D3DXMATRIX worldMatrix, D3DXMATRIX viewMatrix, 
	D3DXMATRIX projectionMatrix, D3DXVECTOR4 lightPosition, D3DXVECTOR4 lightColor, D3DXVECTOR4 globalAmbient,
	D3DXVECTOR4 cameraPosition, D3DXVECTOR4 Ke, D3DXVECTOR4 Ka, D3DXVECTOR4 Kd, D3DXVECTOR4 Ks, 
	D3DXVECTOR3 lightDirection, float shininess)
	{
	bool result;


	// shader.
	result = SetShaderParameters(deviceContext, worldMatrix, viewMatrix, projectionMatrix, lightPosition, lightColor, globalAmbient,
		cameraPosition, Ke,Ka, Kd,Ks,lightDirection, shininess);
	if(!result)
		{
		HR(result);
		return false;
		}

	// ָshaderȾ㻺.
	RenderShader(deviceContext, indexCount);

	return true;
	}

bool LightShaderClass::InitializeShader(ID3D11Device* device, HWND hwnd, WCHAR* vsFilename, WCHAR* psFilename)
	{
	HRESULT result;
	ID3D10Blob* errorMessage;
	ID3D10Blob* vertexShaderBuffer;
	ID3D10Blob* pixelShaderBuffer;
	D3D11_INPUT_ELEMENT_DESC polygonLayout[2];
	unsigned int numElements;
	D3D11_BUFFER_DESC matrixBufferDesc;
	D3D11_BUFFER_DESC lightmaterialBufferDesc;


	// ʼָΪ.
	errorMessage = 0;
	vertexShaderBuffer = 0;
	pixelShaderBuffer = 0;

	// vs.
	//D3D10_SHADER_DEBUGΪperfstuidoв鿴hlsl
	result = D3DX11CompileFromFile(vsFilename, NULL, NULL, "LightVertexShader", "vs_5_0", D3D10_SHADER_ENABLE_STRICTNESS|D3D10_SHADER_DEBUG, 0, NULL, 
		&vertexShaderBuffer, &errorMessage, NULL);
	if(FAILED(result))
		{
		HR(result);
		// vsʧܣϢ
		if(errorMessage)
			{
			OutputShaderErrorMessage(errorMessage, hwnd, vsFilename);
			}
		// ûκδϢshaderļʧ.
		else
			{
			MessageBox(hwnd, vsFilename, L"Missing Shader File", MB_OK);
			}

		return false;
		}

	//  ps.

	result = D3DX11CompileFromFile(psFilename, NULL, NULL, "LightPixelShader", "ps_5_0", D3D10_SHADER_ENABLE_STRICTNESS|D3D10_SHADER_DEBUG, 0, NULL, 
		&pixelShaderBuffer, &errorMessage, NULL);
	if(FAILED(result))
		{
		// psʧܣϢ.
		HR(result);
		if(errorMessage)
			{
			OutputShaderErrorMessage(errorMessage, hwnd, psFilename);
			}
		// ûκδϢshaderļʧ.
		else
			{
			MessageBox(hwnd, psFilename, L"Missing Shader File", MB_OK);
			}

		return false;
		}

	// ӻ崴vs shader.
	result = device->CreateVertexShader(vertexShaderBuffer->GetBufferPointer(), vertexShaderBuffer->GetBufferSize(), NULL, &m_vertexShader);
	if(FAILED(result))
		{
		HR(result);
		return false;
		}

	// ӻдpvs shader.
	result = device->CreatePixelShader(pixelShaderBuffer->GetBufferPointer(), pixelShaderBuffer->GetBufferSize(), NULL, &m_pixelShader);
	if(FAILED(result))
		{
		HR(result);
		return false;
		}

	// ݲ֣Աshaderʹ.
	// ҪModelClassеĶṹһ.
	polygonLayout[0].SemanticName = "POSITION";
	polygonLayout[0].SemanticIndex = 0;
	polygonLayout[0].Format = DXGI_FORMAT_R32G32B32_FLOAT;
	polygonLayout[0].InputSlot = 0;
	polygonLayout[0].AlignedByteOffset = 0;
	polygonLayout[0].InputSlotClass = D3D11_INPUT_PER_VERTEX_DATA;
	polygonLayout[0].InstanceDataStepRate = 0;

	polygonLayout[1].SemanticName = "NORMAL";
	polygonLayout[1].SemanticIndex = 0;
	polygonLayout[1].Format = DXGI_FORMAT_R32G32B32_FLOAT;
	polygonLayout[1].InputSlot = 0;
	polygonLayout[1].AlignedByteOffset = D3D11_APPEND_ALIGNED_ELEMENT;
	polygonLayout[1].InputSlotClass = D3D11_INPUT_PER_VERTEX_DATA;
	polygonLayout[1].InstanceDataStepRate = 0;

	// õlayoutеԪ
	numElements = sizeof(polygonLayout) / sizeof(polygonLayout[0]);

	// 벼.
	result = device->CreateInputLayout(polygonLayout, numElements, vertexShaderBuffer->GetBufferPointer(), vertexShaderBuffer->GetBufferSize(), 
		&m_layout);
	if(FAILED(result))
		{
		HR(result);
		return false;
		}

	//ͷŶػ.
	vertexShaderBuffer->Release();
	vertexShaderBuffer = 0;

	pixelShaderBuffer->Release();
	pixelShaderBuffer = 0;


	// ö̬.
	matrixBufferDesc.Usage = D3D11_USAGE_DYNAMIC;
	matrixBufferDesc.ByteWidth = sizeof(MatrixBufferType);
	matrixBufferDesc.BindFlags = D3D11_BIND_CONSTANT_BUFFER;
	matrixBufferDesc.CPUAccessFlags = D3D11_CPU_ACCESS_WRITE;
	matrixBufferDesc.MiscFlags = 0;
	matrixBufferDesc.StructureByteStride = 0;

	// Create the constant buffer pointer so we can access the vertex shader constant buffer from within this class.
	result = device->CreateBuffer(&matrixBufferDesc, NULL, &m_matrixBuffer);
	if(FAILED(result))
		{
		HR(result);
		return false;
		}

	lightmaterialBufferDesc.Usage = D3D11_USAGE_DYNAMIC;
	lightmaterialBufferDesc.ByteWidth = sizeof(LightMaterialBufferType);
	lightmaterialBufferDesc.BindFlags = D3D11_BIND_CONSTANT_BUFFER;
	lightmaterialBufferDesc.CPUAccessFlags = D3D11_CPU_ACCESS_WRITE;
	lightmaterialBufferDesc.MiscFlags = 0;
	lightmaterialBufferDesc.StructureByteStride = 0;

	// const bufferָ룬Աshader.
	result = device->CreateBuffer(&lightmaterialBufferDesc, NULL, & m_lightmaterialBuffer);
	if(FAILED(result))
		{
		HR(result);
		return false;
		}

	return true;
	}

void LightShaderClass::ShutdownShader()
	{
	// ͷŹղʻ.
	if( m_lightmaterialBuffer)
		{
		m_lightmaterialBuffer->Release();
		m_lightmaterialBuffer = 0;
		}

	// ͷų
	if(m_matrixBuffer)
		{
		m_matrixBuffer->Release();
		m_matrixBuffer = 0;
		}

	//ͷŶ㲼.
	if(m_layout)
		{
		m_layout->Release();
		m_layout = 0;
		}

	// ͷps .
	if(m_pixelShader)
		{
		m_pixelShader->Release();
		m_pixelShader = 0;
		}

	// ͷvs
	if(m_vertexShader)
		{
		m_vertexShader->Release();
		m_vertexShader = 0;
		}
	return;
	}

void LightShaderClass::OutputShaderErrorMessage(ID3D10Blob* errorMessage, HWND hwnd, WCHAR* shaderFilename)
	{
	char* compileErrors;
	unsigned long bufferSize, i;
	ofstream fout;


	// õϢbufferָ.
	compileErrors = (char*)(errorMessage->GetBufferPointer());

	// õbufferĳ.
	bufferSize = errorMessage->GetBufferSize();

	// һļдϢ.
	fout.open("shader-error.txt");

	// .
	for(i=0; i<bufferSize; i++)
		{
		fout << compileErrors[i];
		}

	// رļ
	fout.close();

	// ͷŴϢ.
	errorMessage->Release();
	errorMessage = 0;

	//ʾ.
	MessageBox(hwnd, L"Error compiling shader.  Check shader-error.txt for message.", shaderFilename, MB_OK);

	return;
	}

bool LightShaderClass::SetShaderParameters(ID3D11DeviceContext* deviceContext, D3DXMATRIX worldMatrix, D3DXMATRIX viewMatrix, 
	D3DXMATRIX projectionMatrix, D3DXVECTOR4 lightPosition, D3DXVECTOR4 lightColor, D3DXVECTOR4 globalAmbient,
	D3DXVECTOR4 cameraPosition, D3DXVECTOR4 Ke, D3DXVECTOR4 Ka, D3DXVECTOR4 Kd, D3DXVECTOR4 Ks, 
	D3DXVECTOR3 lightDirection, float shininess)
	{
	HRESULT result;
	D3D11_MAPPED_SUBRESOURCE mappedResource;
	unsigned int bufferNumber;
	MatrixBufferType* dataPtr;
	LightMaterialBufferType* dataPtr2;

	// shaderǰȷתãD3D11Ҫ.
	D3DXMatrixTranspose(&worldMatrix, &worldMatrix);
	D3DXMatrixTranspose(&viewMatrix, &viewMatrix);
	D3DXMatrixTranspose(&projectionMatrix, &projectionMatrix);

	//  壬Աܹд.
	result = deviceContext->Map(m_matrixBuffer, 0, D3D11_MAP_WRITE_DISCARD, 0, &mappedResource);
	if(FAILED(result))
		{
		return false;
		}

	// õconst bufferָ.
	dataPtr = (MatrixBufferType*)mappedResource.pData;

	// world,viewԼprojection.
	dataPtr->world = worldMatrix;
	dataPtr->view = viewMatrix;
	dataPtr->projection = projectionMatrix;

	// .
	deviceContext->Unmap(m_matrixBuffer, 0);

	// óλ.
	bufferNumber = 0;

	// øºֵó.
	deviceContext->VSSetConstantBuffers(bufferNumber, 1, &m_matrixBuffer);


	// ղʻ.
		result = deviceContext->Map(m_lightmaterialBuffer, 0, D3D11_MAP_WRITE_DISCARD, 0, &mappedResource);
	if(FAILED(result))
		{
		return false;
		}

	//õָ
	dataPtr2 = (LightMaterialBufferType*)mappedResource.pData;

	// 帳ֵ.
	dataPtr2->lightPosition = lightPosition;
	dataPtr2->lightColor = lightColor;
	dataPtr2->cameraPosition = cameraPosition;
	dataPtr2->globalAmbient = globalAmbient;
	dataPtr2->Ke = Ke;
	dataPtr2->Ka = Ke;
	dataPtr2->Kd = Kd;
	dataPtr2->Ks = Ks;
	dataPtr2->lightDirection = lightDirection;
	dataPtr2->shininess = shininess;

	// 
	deviceContext->Unmap(m_lightmaterialBuffer, 0);

	// ûΪ0Ϊpsеĵһ
	bufferNumber =0;

	// ùղʳ.
	deviceContext->PSSetConstantBuffers(bufferNumber, 1, &m_lightmaterialBuffer);

	
	return true;
	}

void LightShaderClass::RenderShader(ID3D11DeviceContext* deviceContext, int indexCount)
	{
	// 󶨶㲼.
	deviceContext->IASetInputLayout(m_layout);

	// Ⱦʹvsps.
	deviceContext->VSSetShader(m_vertexShader, NULL, 0);
	deviceContext->PSSetShader(m_pixelShader, NULL, 0);

	// Ⱦ
	deviceContext->DrawIndexed(indexCount, 0, 0);

	return;
	}
