#pragma once
#include <d3d11.h>
#include <d3dx10math.h>
#include <d3dx11async.h>
#include <fstream>
#include "common.h"
#include "LightClass.h"

using namespace std;

class LightShaderClass
	{
	private:
	//shaderconst bufferṹһ£ҪЩshaderֵ
	struct MatrixBufferType
		{
		D3DXMATRIX world;
		D3DXMATRIX view;
		D3DXMATRIX projection;
		};

	struct  LightMaterialBufferType
		{
		D3DXVECTOR4 lightPosition[NUM_LIGHTS]; //Դλ
		D3DXVECTOR4 lightColor[NUM_LIGHTS];   //Դɫ
		D3DXVECTOR4 globalAmbient[NUM_LIGHTS]; //ԴĻⷴϵ
		D3DXVECTOR4 cameraPosition; //λ
		D3DXVECTOR4 Ke[NUM_LIGHTS];  //ʵԷ
		D3DXVECTOR4 Ka[NUM_LIGHTS];  //ʵĻϵ
		D3DXVECTOR4 Kd[NUM_LIGHTS];  //ʵϵ
		D3DXVECTOR4 Ks[NUM_LIGHTS];  //ʵĸ߹ϵ
		D3DXVECTOR3 lightDirection[NUM_LIGHTS]; //ƽйⷽ
		float shininess[NUM_LIGHTS]; //߹ָ
		
		};
	public:
		LightShaderClass(void);
		LightShaderClass(const LightShaderClass &);
		~LightShaderClass(void);
		bool Initialize(ID3D11Device*, HWND);
		void Shutdown();
		bool Render(ID3D11DeviceContext* , int , D3DXMATRIX , D3DXMATRIX , D3DXMATRIX , D3DXVECTOR4);
		bool InitializeShader(ID3D11Device*, HWND, WCHAR*, WCHAR*);
		void ShutdownShader();
		void OutputShaderErrorMessage(ID3D10Blob*, HWND, WCHAR*);

		bool SetShaderParameters(ID3D11DeviceContext* , D3DXMATRIX , D3DXMATRIX , D3DXMATRIX, D3DXVECTOR4);
		void RenderShader(ID3D11DeviceContext*, int);

	private:
		ID3D11VertexShader* m_vertexShader;
		ID3D11PixelShader* m_pixelShader;
		ID3D11InputLayout* m_layout;
		ID3D11Buffer* m_matrixBuffer;
		ID3D11Buffer* m_lightmaterialBuffer; //ʹղbuffer
	};

