#include "SystemClass.h"


SystemClass::SystemClass(void)
	{
	m_Input = 0;
	m_Graphics = 0;
	}

SystemClass::SystemClass(const SystemClass &)
	{

	}

SystemClass::~SystemClass(void)
	{
	}

//ôڳʼһЩĳʼ
bool SystemClass::Initialize()
	{
	bool result;
	int screenWidth = 0, screenHeight = 0;

	// ʼ
	InitializeWindows(screenWidth, screenHeight);

	//input
	m_Input = new InputClass;
	if(!m_Input)
		{
		return false;
		}

	// ʼ.
	m_Input->Initialize();

	// ͼζȾӦóе
	m_Graphics = new GraphicsClass;
	if(!m_Graphics)
		{
		return false;
		}
	// ʼͼζ
	result = m_Graphics->Initialize(screenWidth, screenHeight, m_hwnd);
	if(!result)
		{
		return false;
		}


	return true;
	}

void SystemClass::Shutdown()
	{
	//һЩٹ
	if(m_Graphics)
		{
		m_Graphics->Shutdown();
		delete m_Graphics;
		m_Graphics = 0;
		}

	if(m_Input)
		{
		delete m_Input;
		m_Input = 0;
		}
	// ִһЩٹ.
	ShutdownWindows();

	}

//Ϣ
void  SystemClass::Run()
	{
	MSG msg;
	bool done, result ;


	// ʼϢṹ.
	ZeroMemory(&msg, sizeof(MSG));

	// ѭϢյWM_QUIT.
	done = false;
	while(!done)
		{
		// windowsϢ.
		if(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
			{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
			}

		// յWM_QUITϢ˳.
		if(msg.message == WM_QUIT)
			{
			done = true;
			}
		else
			{

			//ǵȾԷ
			//....
			//.....
			result = Frame();
			if(!result)
				{
				done = true;
				}
			}

		}

	return;
	}

bool SystemClass::Frame()
	{
	bool result;


	//ûǷESC£˳.
	if(m_Input->IsKeyDown(VK_ESCAPE))
		{
		return false;
		}

	// ִ֡Ⱦ.
	result = m_Graphics->Frame();
	if(!result)
		{
		return false;
		}
	return true;
	}

//ʼ࣬Ӧó򴰿
void SystemClass::InitializeWindows(int& screenWidth, int& screenHeight)
	{
	WNDCLASSEX wc;
	DEVMODE dmScreenSettings;
	int posX, posY;

	//õӦóָ
	ApplicationHandle = this;

	// õӦóʵ
	m_hinstance = GetModuleHandle(NULL);

	// Ӧó
	m_applicationName = L"Engine";

	// ô.
	wc.style         = CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
	wc.lpfnWndProc   = WndProc; //ָص
	wc.cbClsExtra    = 0;
	wc.cbWndExtra    = 0;
	wc.hInstance     = m_hinstance;
	wc.hIcon		 = LoadIcon(NULL, IDI_WINLOGO);
	wc.hIconSm       = wc.hIcon;
	wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH); //ĬϺɫںɫ
	wc.lpszMenuName  = NULL;
	wc.lpszClassName = m_applicationName;
	wc.cbSize        = sizeof(WNDCLASSEX);

	// עᴰ
	RegisterClassEx(&wc);

	// õwindowsֱ
	screenWidth  = GetSystemMetrics(SM_CXSCREEN);
	screenHeight = GetSystemMetrics(SM_CYSCREEN);

	// Ƿȫòͬķֱ.
	if(FULL_SCREEN)
		{
		//ȫģʽ£ôڴСΪwindowsֱ.
		memset(&dmScreenSettings, 0, sizeof(dmScreenSettings));
		dmScreenSettings.dmSize       = sizeof(dmScreenSettings);
		dmScreenSettings.dmPelsWidth  = (unsigned long)screenWidth;
		dmScreenSettings.dmPelsHeight = (unsigned long)screenHeight;
		dmScreenSettings.dmBitsPerPel = 32;			
		dmScreenSettings.dmFields     = DM_BITSPERPEL | DM_PELSWIDTH | DM_PELSHEIGHT;

		// ʱʾ豸Ϊȫģʽע⣺Ӧó˳ʱ򣬽ָϵͳĬá
		ChangeDisplaySettings(&dmScreenSettings, CDS_FULLSCREEN);

		// ôڵĬλΪ(0,0).
		posX = posY = 0;
		}
	else
		{
		// ģʽ800*600.
		screenWidth  = 800;
		screenHeight = 600;

		// λ,posX, posYϽ
		posX = (GetSystemMetrics(SM_CXSCREEN) - screenWidth)  / 2;
		posY = (GetSystemMetrics(SM_CYSCREEN) - screenHeight) / 2;
		}

	// ȫʹʹòͬĲ.
	if( FULL_SCREEN)
		{
		m_hwnd = CreateWindowEx(WS_EX_APPWINDOW, m_applicationName, m_applicationName, 
			WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_POPUP,
			posX, posY, screenWidth, screenHeight, NULL, NULL, m_hinstance, NULL);
		}
	else
		{
		m_hwnd = CreateWindowEx(WS_EX_APPWINDOW, m_applicationName, m_applicationName, 
			WS_OVERLAPPEDWINDOW,
			posX, posY, screenWidth, screenHeight, NULL, NULL, m_hinstance, NULL);
		}

	// ʾڲΪ.
	ShowWindow(m_hwnd, SW_SHOW);
	SetForegroundWindow(m_hwnd);
	SetFocus(m_hwnd);

	// .
	//ShowCursor(false);


	}

void SystemClass::ShutdownWindows()
	{
	//ʾ.
	//ShowCursor(true);

	// ָĬʾ.
	if(FULL_SCREEN)
		{
		ChangeDisplaySettings(NULL, 0);
		}

	// ٴ
	DestroyWindow(m_hwnd);
	m_hwnd = NULL;

	// Ӧóʵ.
	UnregisterClass(m_applicationName, m_hinstance);
	m_hinstance = NULL;
	ApplicationHandle = NULL;

	return;

	}

LRESULT CALLBACK SystemClass::MessageHandler(HWND hwnd, UINT umsg, WPARAM wparam, LPARAM lparam)
	{

	switch(umsg)
		{
		// ⰴϢ.
	case WM_KEYDOWN:
		{
		m_Input->KeyDown((unsigned int)wparam);
		return 0;
		}

	case WM_KEYUP:
		{
		m_Input->KeyUp((unsigned int)wparam);
		return 0;
		}
		//κϢ͵windowsȱʡ.
	default:
		{
		return DefWindowProc(hwnd, umsg, wparam, lparam);
		}
		}
	}

LRESULT CALLBACK WndProc(HWND hwnd, UINT umessage, WPARAM wparam, LPARAM lparam)
	{
	switch(umessage)
		{

		// Ϣ.
	case WM_DESTROY:
		{
		PostQuitMessage(0);
		return 0;
		}

		// ڹرϢ.
	case WM_CLOSE:
		{
		PostQuitMessage(0);		
		return 0;
		}

		//MessageHandle̴Ϣ.
	default:
		{
		return ApplicationHandle->MessageHandler(hwnd, umessage, wparam, lparam);
		}
		}
	}