#include "ModelClass.h"


ModelClass::ModelClass(void)
	{
	m_vertexBuffer = 0;
	m_indexBuffer = 0;

	}

ModelClass::ModelClass(const ModelClass & others)
	{

	}

ModelClass::~ModelClass(void)
	{
	}

bool ModelClass::Initialize(ID3D11Device* device)
	{
	bool result;


	// ʼ㻺Ͷ.
	result = InitializeBuffers(device);
	if(!result)
		{
		return false;
		}

	return true;
	}

void ModelClass::Shutdown()
	{
	// ͷŶ.
	ShutdownBuffers();

	return;
	}

void ModelClass::Render(ID3D11DeviceContext* deviceContext)
	{
	// Ѷͼιߣ׼Ⱦ.
	RenderBuffers(deviceContext);

	return;
	}

int ModelClass::GetIndexCount()
	{
	//
	return m_indexCount;
	}

bool ModelClass::InitializeBuffers(ID3D11Device* device)
	{
	VertexType* vertices;
	unsigned long* indices;
	D3D11_BUFFER_DESC vertexBufferDesc, indexBufferDesc;
	D3D11_SUBRESOURCE_DATA vertexData, indexData;
	HRESULT result;

	//ȣǴ2ʱŶݣԱʹá. 

	// ö㻺СΪ3һ.
	m_vertexCount = 3;

	// С.
	m_indexCount = 3;

	// ʱ.
	vertices = new VertexType[m_vertexCount];
	if(!vertices)
		{
		return false;
		}

	// .
	indices = new unsigned long[m_indexCount];
	if(!indices)
		{
		return false;
		}
	//˳ʱ뷽Σֹ
	// ö.
	vertices[0].position = D3DXVECTOR3(-1.0f, -1.0f, 0.0f);  // 
	vertices[0].color = D3DXVECTOR4(1.0f, 1.0f, 0.0f, 1.0f);

	vertices[1].position = D3DXVECTOR3(0.0f, 1.0f, 0.0f);  // .
	vertices[1].color = D3DXVECTOR4(0.0f, 1.0f, 0.0f, 1.0f);

	vertices[2].position = D3DXVECTOR3(1.0f, -1.0f, 0.0f);  // 
	vertices[2].color = D3DXVECTOR4(0.0f, 1.0f, 1.0f, 1.0f);

	// .
	indices[0] = 0;  // Bottom left.
	indices[1] = 1;  // Top middle.
	indices[2] = 2;  // Bottom right.

	// ö㻺
	vertexBufferDesc.Usage = D3D11_USAGE_DEFAULT;
	vertexBufferDesc.ByteWidth = sizeof(VertexType) * m_vertexCount;
	vertexBufferDesc.BindFlags = D3D11_BIND_VERTEX_BUFFER;
	vertexBufferDesc.CPUAccessFlags = 0;
	vertexBufferDesc.MiscFlags = 0;
	vertexBufferDesc.StructureByteStride = 0;

	// ָ򱣴涥ݵʱ.
	vertexData.pSysMem = vertices;
	vertexData.SysMemPitch = 0;
	vertexData.SysMemSlicePitch = 0;

	// 㻺.
	result = device->CreateBuffer(&vertexBufferDesc, &vertexData, &m_vertexBuffer);
	if(FAILED(result))
		{
		return false;
		}

	// .
	indexBufferDesc.Usage = D3D11_USAGE_DEFAULT;
	indexBufferDesc.ByteWidth = sizeof(unsigned long) * m_indexCount;
	indexBufferDesc.BindFlags = D3D11_BIND_INDEX_BUFFER;
	indexBufferDesc.CPUAccessFlags = 0;
	indexBufferDesc.MiscFlags = 0;
	indexBufferDesc.StructureByteStride = 0;

	// ָʱ.
	indexData.pSysMem = indices;
	indexData.SysMemPitch = 0;
	indexData.SysMemSlicePitch = 0;

	// .
	result = device->CreateBuffer(&indexBufferDesc, &indexData, &m_indexBuffer);
	if(FAILED(result))
		{
		return false;
		}

	// ͷʱ.
	delete [] vertices;
	vertices = 0;

	delete [] indices;
	indices = 0;

	return true;
	}

void ModelClass::ShutdownBuffers()
	{
	// ͷŶ㻺.
	if(m_indexBuffer)
		{
		m_indexBuffer->Release();
		m_indexBuffer = 0;
		}

	// ͷ
	if(m_vertexBuffer)
		{
		m_vertexBuffer->Release();
		m_vertexBuffer = 0;
		}

	return;
	}

void ModelClass::RenderBuffers(ID3D11DeviceContext* deviceContext)
	{
	unsigned int stride;
	unsigned int offset;


	// ö㻺Ⱥƫ.
	stride = sizeof(VertexType); 
	offset = 0;

	//input assemberl׶ΰ󶨶㻺壬ԱܹȾ
	deviceContext->IASetVertexBuffers(0, 1, &m_vertexBuffer, &stride, &offset);

	//input assemberl׶ΰ壬ԱܹȾ
	deviceContext->IASetIndexBuffer(m_indexBuffer, DXGI_FORMAT_R32_UINT, 0);

	// Ԫ壬Ⱦб.
	deviceContext->IASetPrimitiveTopology(D3D11_PRIMITIVE_TOPOLOGY_TRIANGLELIST);

	return;
	}

